Index: code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc
===================================================================
--- code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc	(revision 8796)
+++ code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc	(revision 8797)
@@ -391,18 +391,4 @@
     }
 
-    //! Called if only the last output-line has changed
-    void IOConsole::onlyLastLineChanged()
-    {
-        // Save cursor position and move it to the beginning of the first output line
-        this->cout_ << "\033[s\033[1A\033[1G";
-        // Erase the line
-        this->cout_ << "\033[K";
-        // Reprint the last output line
-        this->printOutputLine(this->shell_->getNewestLineIterator()->first, this->shell_->getNewestLineIterator()->second);
-        // Restore cursor
-        this->cout_ << "\033[u";
-        this->cout_.flush();
-    }
-
     //! Called if a new output-line was added
     void IOConsole::lineAdded()
Index: code/branches/output/src/libraries/core/command/IOConsolePOSIX.h
===================================================================
--- code/branches/output/src/libraries/core/command/IOConsolePOSIX.h	(revision 8796)
+++ code/branches/output/src/libraries/core/command/IOConsolePOSIX.h	(revision 8797)
@@ -66,5 +66,4 @@
         // Methods from ShellListener
         void linesChanged();
-        void onlyLastLineChanged();
         void lineAdded();
         void inputChanged();
Index: code/branches/output/src/libraries/core/command/IOConsoleWindows.cc
===================================================================
--- code/branches/output/src/libraries/core/command/IOConsoleWindows.cc	(revision 8796)
+++ code/branches/output/src/libraries/core/command/IOConsoleWindows.cc	(revision 8797)
@@ -388,18 +388,4 @@
     }
 
-    //! Called if only the last output-line has changed
-    void IOConsole::onlyLastLineChanged()
-    {
-        int newLineHeight = 1 + this->shell_->getNewestLineIterator()->first.size() / this->terminalWidth_;
-        // Compute the number of new lines needed
-        int newLines = newLineHeight - this->lastOutputLineHeight_;
-        this->lastOutputLineHeight_ = newLineHeight;
-        // Scroll console if necessary
-        if (newLines > 0) // newLines < 0 is assumed impossible
-            this->createNewOutputLines(newLines);
-        Shell::LineList::const_iterator it = this->shell_->getNewestLineIterator();
-        this->printOutputLine(it->first, it->second, makeCOORD(0, this->inputLineRow_ - newLineHeight));
-    }
-
     //! Called if a new output line was added
     void IOConsole::lineAdded()
Index: code/branches/output/src/libraries/core/command/IOConsoleWindows.h
===================================================================
--- code/branches/output/src/libraries/core/command/IOConsoleWindows.h	(revision 8796)
+++ code/branches/output/src/libraries/core/command/IOConsoleWindows.h	(revision 8797)
@@ -68,5 +68,4 @@
         // Methods from ShellListener
         void linesChanged();
-        void onlyLastLineChanged();
         void lineAdded();
         void inputChanged();
Index: code/branches/output/src/libraries/core/command/Shell.h
===================================================================
--- code/branches/output/src/libraries/core/command/Shell.h	(revision 8796)
+++ code/branches/output/src/libraries/core/command/Shell.h	(revision 8797)
@@ -66,5 +66,4 @@
         private:
             virtual void linesChanged() {}          ///< Called if all output-lines have changed
-            virtual void onlyLastLineChanged() {}   ///< Called if only the last output-line has changed
             virtual void lineAdded() {}             ///< Called if a new line was added to the output
             virtual void inputChanged() {}          ///< Called if the input has changed
Index: code/branches/output/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/branches/output/src/orxonox/overlays/InGameConsole.cc	(revision 8796)
+++ code/branches/output/src/orxonox/overlays/InGameConsole.cc	(revision 8797)
@@ -299,20 +299,12 @@
 
     /**
-        @brief Called if only the last output-line has changed.
-    */
-    void InGameConsole::onlyLastLineChanged()
-    {
+        @brief Called if a new output-line was added.
+    */
+    void InGameConsole::lineAdded()
+    {
+        this->numLinesShifted_ = 0;
+        this->shiftLines();
         if (LINES > 1)
             this->print(this->shell_->getNewestLineIterator()->first, this->shell_->getNewestLineIterator()->second, 1);
-    }
-
-    /**
-        @brief Called if a new output-line was added.
-    */
-    void InGameConsole::lineAdded()
-    {
-        this->numLinesShifted_ = 0;
-        this->shiftLines();
-        this->onlyLastLineChanged();
     }
 
Index: code/branches/output/src/orxonox/overlays/InGameConsole.h
===================================================================
--- code/branches/output/src/orxonox/overlays/InGameConsole.h	(revision 8796)
+++ code/branches/output/src/orxonox/overlays/InGameConsole.h	(revision 8797)
@@ -64,5 +64,4 @@
 
         void linesChanged();
-        void onlyLastLineChanged();
         void lineAdded();
         void inputChanged();