Index: code/branches/output/src/libraries/core/command/ArgumentCompletionFunctions.cc
===================================================================
--- code/branches/output/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 8801)
+++ code/branches/output/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 8803)
@@ -90,5 +90,5 @@
             ArgumentCompletionList _groupsandcommands(const std::string& fragment, bool bOnlyShowHidden)
             {
-                // note: this function returns only arguments that begin with "fragment", which would't be necessary for the
+                // note: this function returns only arguments that begin with "fragment", which wouldn't be necessary for the
                 //       auto-completion, but it's necessary to place the line-break "\n" between groups and commands
                 //       only if both groups AND commands are in the list.
Index: code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc
===================================================================
--- code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc	(revision 8801)
+++ code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc	(revision 8803)
@@ -382,5 +382,5 @@
     void IOConsole::executed()
     {
-        this->shell_->addOutput(this->promptString_ + this->shell_->getInput() + '\n', Shell::Command);
+        this->shell_->addOutput(this->promptString_ + this->shell_->getInput(), Shell::Command);
     }
 
Index: code/branches/output/src/libraries/core/command/IOConsoleWindows.cc
===================================================================
--- code/branches/output/src/libraries/core/command/IOConsoleWindows.cc	(revision 8801)
+++ code/branches/output/src/libraries/core/command/IOConsoleWindows.cc	(revision 8803)
@@ -329,5 +329,5 @@
     void IOConsole::executed()
     {
-        this->shell_->addOutput(this->promptString_ + this->shell_->getInput() + '\n', Shell::Command);
+        this->shell_->addOutput(this->promptString_ + this->shell_->getInput(), Shell::Command);
     }
 
Index: code/branches/output/src/libraries/core/command/Shell.cc
===================================================================
--- code/branches/output/src/libraries/core/command/Shell.cc	(revision 8801)
+++ code/branches/output/src/libraries/core/command/Shell.cc	(revision 8803)
@@ -395,5 +395,5 @@
         else if (result != "")
         {
-            this->addOutput(result, Command);
+            this->addOutput(result, Result);
         }
 
Index: code/branches/output/src/libraries/core/command/Shell.h
===================================================================
--- code/branches/output/src/libraries/core/command/Shell.h	(revision 8801)
+++ code/branches/output/src/libraries/core/command/Shell.h	(revision 8803)
@@ -105,4 +105,5 @@
                 Input,
                 Command,
+                Result,
                 Hint
             };
Index: code/branches/output/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/branches/output/src/orxonox/overlays/InGameConsole.cc	(revision 8801)
+++ code/branches/output/src/orxonox/overlays/InGameConsole.cc	(revision 8803)
@@ -59,5 +59,5 @@
 {
     const int LINES = 30;
-    const float CHAR_WIDTH = 7.45f; // fix this please - determine the char-width dynamically
+    const float CHAR_WIDTH = 8.0f; // fix this please - determine the char-width dynamically
 
     SetConsoleCommand("InGameConsole", "openConsole", &InGameConsole::openConsole);
@@ -339,5 +339,5 @@
     void InGameConsole::executed()
     {
-        this->shell_->addOutput(this->shell_->getInput() + '\n', Shell::Command);
+        this->shell_->addOutput(this->shell_->getInput(), Shell::Command);
     }
 
@@ -430,5 +430,5 @@
 
         // now adjust the text lines...
-        this->desiredTextWidth_ = static_cast<int>(this->windowW_ * this->relativeWidth) - 12;
+        this->desiredTextWidth_ = static_cast<int>(this->windowW_ * this->relativeWidth) - 24;
 
         if (LINES > 0)