Index: /code/branches/output/src/libraries/core/GUIManager.cc
===================================================================
--- /code/branches/output/src/libraries/core/GUIManager.cc	(revision 8804)
+++ /code/branches/output/src/libraries/core/GUIManager.cc	(revision 8805)
@@ -93,12 +93,4 @@
 namespace orxonox
 {
-    namespace context
-    {
-        namespace
-        {
-            REGISTER_OUTPUT_CONTEXT(cegui);
-        }
-    }
-
     static void key_esc()
         { GUIManager::getInstance().keyESC(); }
Index: /code/branches/output/src/libraries/core/GraphicsManager.cc
===================================================================
--- /code/branches/output/src/libraries/core/GraphicsManager.cc	(revision 8804)
+++ /code/branches/output/src/libraries/core/GraphicsManager.cc	(revision 8805)
@@ -68,12 +68,4 @@
 namespace orxonox
 {
-    namespace context
-    {
-        namespace
-        {
-            REGISTER_OUTPUT_CONTEXT(ogre);
-        }
-    }
-
     static const std::string __CC_GraphicsManager_group = "GraphicsManager";
     static const std::string __CC_setScreenResolution_name = "setScreenResolution";
Index: /code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc
===================================================================
--- /code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc	(revision 8804)
+++ /code/branches/output/src/libraries/core/command/IOConsolePOSIX.cc	(revision 8805)
@@ -240,4 +240,5 @@
         switch (type)
         {
+            case Shell::Message:
             case Shell::DebugOutput:     this->cout_ << "\033[0m"; break;
 
Index: /code/branches/output/src/libraries/core/command/IOConsoleWindows.cc
===================================================================
--- /code/branches/output/src/libraries/core/command/IOConsoleWindows.cc	(revision 8804)
+++ /code/branches/output/src/libraries/core/command/IOConsoleWindows.cc	(revision 8805)
@@ -201,4 +201,5 @@
         switch (type)
         {
+            case Shell::Message:
             case Shell::DebugOutput:     colour = FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE; break;
 
@@ -249,5 +250,5 @@
             || !SetConsoleMode(this->stdInHandle_, 0))
         {
-            COUT(1) << "Error: Could not set Windows console settings" << std::endl;
+            orxout(user_error) << "Error: Could not set Windows console settings" << endl;
             return;
         }
Index: /code/branches/output/src/libraries/core/command/Shell.h
===================================================================
--- /code/branches/output/src/libraries/core/command/Shell.h	(revision 8804)
+++ /code/branches/output/src/libraries/core/command/Shell.h	(revision 8805)
@@ -91,4 +91,5 @@
             {
                 DebugOutput     = debug_output,
+                Message         = message,
                 UserError       = user_error,
                 UserWarning     = user_warning,
Index: /code/branches/output/src/libraries/util/output/OutputDefinitions.h
===================================================================
--- /code/branches/output/src/libraries/util/output/OutputDefinitions.h	(revision 8804)
+++ /code/branches/output/src/libraries/util/output/OutputDefinitions.h	(revision 8805)
@@ -45,16 +45,17 @@
         static const OutputLevel none             = 0x0000;
 
-        static const OutputLevel debug_output     = 0x0001;
-        static const OutputLevel user_error       = 0x0002;
-        static const OutputLevel user_warning     = 0x0004;
-        static const OutputLevel user_status      = 0x0008;
-        static const OutputLevel user_info        = 0x0010;
-        static const OutputLevel internal_error   = 0x0020;
-        static const OutputLevel internal_warning = 0x0040;
-        static const OutputLevel internal_status  = 0x0080;
-        static const OutputLevel internal_info    = 0x0100;
-        static const OutputLevel verbose          = 0x0200;
-        static const OutputLevel verbose_more     = 0x0400;
-        static const OutputLevel verbose_ultra    = 0x0800;
+        static const OutputLevel message          = 0x0001;
+        static const OutputLevel debug_output     = 0x0002;
+        static const OutputLevel user_error       = 0x0004;
+        static const OutputLevel user_warning     = 0x0008;
+        static const OutputLevel user_status      = 0x0010;
+        static const OutputLevel user_info        = 0x0020;
+        static const OutputLevel internal_error   = 0x0040;
+        static const OutputLevel internal_warning = 0x0080;
+        static const OutputLevel internal_status  = 0x0100;
+        static const OutputLevel internal_info    = 0x0200;
+        static const OutputLevel verbose          = 0x0400;
+        static const OutputLevel verbose_more     = 0x0800;
+        static const OutputLevel verbose_ultra    = 0x1000;
     }
 
@@ -73,9 +74,18 @@
             REGISTER_OUTPUT_CONTEXT(undefined);
 
-            REGISTER_OUTPUT_CONTEXT(test1);
-            REGISTER_OUTPUT_CONTEXT(test2);
-            REGISTER_OUTPUT_CONTEXT(output);
+            REGISTER_OUTPUT_CONTEXT(ogre);
+            REGISTER_OUTPUT_CONTEXT(cegui);
             REGISTER_OUTPUT_CONTEXT(lua);
             REGISTER_OUTPUT_CONTEXT(tcl);
+            REGISTER_OUTPUT_CONTEXT(identifier);
+            REGISTER_OUTPUT_CONTEXT(object_list);
+            REGISTER_OUTPUT_CONTEXT(super);
+            REGISTER_OUTPUT_CONTEXT(language);
+            REGISTER_OUTPUT_CONTEXT(output);
+            REGISTER_OUTPUT_CONTEXT(commands);
+            REGISTER_OUTPUT_CONTEXT(executor);
+            REGISTER_OUTPUT_CONTEXT(input);
+            REGISTER_OUTPUT_CONTEXT(events);
+            REGISTER_OUTPUT_CONTEXT(config);
         }
     }
Index: /code/branches/output/src/libraries/util/output/OutputManager.cc
===================================================================
--- /code/branches/output/src/libraries/util/output/OutputManager.cc	(revision 8804)
+++ /code/branches/output/src/libraries/util/output/OutputManager.cc	(revision 8805)
@@ -136,4 +136,5 @@
         {
             case level::none:               { static std::string name = "None"; return name; }
+            case level::message:            { static std::string name = "Message"; return name; }
             case level::debug_output:       { static std::string name = "Debug"; return name; }
             case level::user_error:         { static std::string name = "Error"; return name; }
Index: /code/branches/output/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- /code/branches/output/src/orxonox/overlays/InGameConsole.cc	(revision 8804)
+++ /code/branches/output/src/orxonox/overlays/InGameConsole.cc	(revision 8805)
@@ -559,4 +559,5 @@
         switch (type)
         {
+            case Shell::Message:
             case Shell::DebugOutput:     colourTop = ColourValue(0.9f, 0.9f, 0.9f); break;
 